#include <iostream>

#include <thrift/protocol/TBinaryProtocol.h>
#include <thrift/transport/TSocket.h>
#include <thrift/transport/TTransportUtils.h>
#include "..\POCService.Shared\pocservice_types.h"
#include "..\POCService.Shared\POCService.h"


using namespace std;
using namespace apache::thrift;
using namespace apache::thrift::protocol;
using namespace apache::thrift::transport;

int main()
{
	boost::shared_ptr<TTransport> socket(new TSocket("localhost", 9090));
	boost::shared_ptr<TTransport> transport(new TBufferedTransport(socket));
	boost::shared_ptr<TProtocol> protocol(new TBinaryProtocol(transport));

	POCServiceClient client(protocol);

	try {
		transport->open();
		ObjectPosition obj;
		obj.X = 10;
		obj.Y = 20;
		obj.Identifier = "Olivier";

		client.AddObjectPosition(obj);
		cout << "AddObjectPosition()" << endl;

		vector<ObjectPosition> objects;
		client.GetAllObjectPositions(objects);

		cout << "Size of vector: " << objects.size() << endl;
	}
	catch (TException& tx) {
		cout << "ERROR: " << tx.what() << endl;
	}
	return 0;
}