﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Thrift.Transport;
using Thrift.Protocol;

namespace POCService.ClientCSharp
{
    class Program
    {
        static void Main(string[] args)
        {
            //Thrift.Transport.TTransport Transport
            TTransport transport = new TSocket("localhost", 9090);
            transport.Open();
            TProtocol protocol = new TBinaryProtocol(transport);

            POCServiceC.Client client = new POCServiceC.Client(protocol);

            //call Ping()
            client.ping();
            Console.WriteLine("Ping");

            //call AddObjectPosition(obj);
            ObjectPosition obj = new ObjectPosition();
            obj.X = 20;
            obj.Y = 30;
            obj.Identifier = "Olivier";
            client.AddObjectPosition(obj);
            Console.WriteLine("AddObjectPosition");

            //call AddObjectPosition(obj);
            List<ObjectPosition> res = client.GetAllObjectPositions();
            Console.WriteLine("Number of positions: " + res.Count);
            Console.ReadLine();
        }
    }
}
