// This autogenerated skeleton file illustrates how to build a server.
// You should copy it to another filename to avoid overwriting it.

#include <iostream>

#include "../POCService.Shared/pocservice_types.h"
#include "../POCService.Shared/POCService.h"


#include <thrift/protocol/TBinaryProtocol.h>
#include <thrift/server/TSimpleServer.h>
#include <thrift/transport/TServerSocket.h>
#include <thrift/transport/TBufferTransports.h>

using namespace std;

using namespace ::apache::thrift;
using namespace ::apache::thrift::protocol;
using namespace ::apache::thrift::transport;
using namespace ::apache::thrift::server;

using boost::shared_ptr;

class POCServiceHandler : virtual public POCServiceIf {
public:
	POCServiceHandler() {
	}

	void ping() {
		printf("ping\n");
	}

	void AddObjectPosition(const ObjectPosition& position) {
		dataInMemory.push_back(position);
		printf("AddObjectPosition\n");
	}

	void GetAllObjectPositions(std::vector<ObjectPosition> & _return) {
		printf("GetAllObjectPositions\n");
		_return = dataInMemory;
	}

private:
	vector<ObjectPosition> dataInMemory;
};

int main(int argc, char **argv) {
	int port = 9090;
	boost::shared_ptr<POCServiceHandler> handler(new POCServiceHandler());
	boost::shared_ptr<TProcessor> processor(new POCServiceProcessor(handler));
	boost::shared_ptr<TServerTransport> serverTransport(new TServerSocket(port));
	boost::shared_ptr<TTransportFactory> transportFactory(new TBufferedTransportFactory());
	boost::shared_ptr<TProtocolFactory> protocolFactory(new TBinaryProtocolFactory());

	TSimpleServer server(processor, serverTransport, transportFactory, protocolFactory);
	cout << "Starting the server..." << endl;
	server.serve();
	cout << "Done." << endl;
	return 0;
}

